% Converts an arcasciigrid imported into MATLAB into an XYZ file for
% importing into Delft3D QUICKIN
% RLS -- January 2008
clear all; close all
filename = 'raster_offshorebathyclip.txt';
fid = fopen(filename);
C = textscan(fid,'%s %n', 1);
ncols = C{2};
C = textscan(fid,'%s %n', 1);
nrows = C{2};
C = textscan(fid,'%s %n', 1);
xllcorner = C{2};
C = textscan(fid,'%s %n', 1);
yllcorner = C{2};
C = textscan(fid,'%s %n', 1);
cellsize  = C{2};
C = textscan(fid,'%s %n', 1);
NODATA_value = C{2}; 
nsize = ncols*nrows;
B=zeros(nsize,3);
A = fscanf(fid,'%f',nsize);
%AA=flipud(A);
k=1;
for i = 1:nrows
    for j = 1:ncols
        B(k,1) = xllcorner + cellsize*j-1;
%        B(k,2) = yllcorner + cellsize*i-1;
        B(k,2) = 3.276845220463400e06 - cellsize*i-1;
        B(k,3) = -A(k);
        if B(k,3) > 40;
            B(k,3) = 0;
        end
        k = k + 1;
    end
end
k=1;
for i=1:50:nsize
    BB(k,1) = B(i,1);
    BB(k,2) = B(i,2);
    BB(k,3) = B(i,3);
    k=k+1;
end
scatter(BB(:,1),BB(:,2),5,BB(:,3))
save -ascii raster_bathy.XYZ BB

